package gonganxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/api"
	"shylinux.com/x/community/src/gonganxitong/model"
)

type meeting struct {
	Table
	order  string `data:"91"`
	fields string `data:"vendor,user_id"`
	join   string `name:"join" help:"入会" style:"notice" role:"void"`
	config string `name:"config place_uid user_id vendor"`
}

func (s meeting) Init(m *ice.Message, arg ...string) {
	m.Design(s.List, "", kit.JoinWord(s.PLACE_UID, "meeting_code", ice.AUTO))
	s.Table.Init(m, arg...)
}
func (s meeting) List(m *ice.Message, arg ...string) {
	if !m.WarnNotRight(!s.IsWorker(m)) {
		m.Option(s.PLACE_UID, arg[0])
		if s.cmdy(m, s.MeetingList, s.authUID(m, arg...), arg[1:]); m.Length() > 0 {
			if len(arg) == 1 {
				m.PushAction(s.Join).Display("")
			} else if m.IsMobileUA() {
				m.Options(ice.MSG_BG, "white").EchoQRCode(m.Append(model.LINK)).Action().Display("").DisplayCSS("")
			} else {
				m.EchoIFrame(m.Append(model.LINK)).SetAppend().Action()
			}
		}
	}
}

func (s meeting) Config(m *ice.Message, arg ...string) {
	if s.Select(m, model.PLACE_UID, m.Option(model.PLACE_UID)).Length() == 0 {
		s.Insert(m, arg...)
	} else {
		s.Update(m, arg, model.PLACE_UID, m.Option(model.PLACE_UID))
	}
}
func (s meeting) MeetingList(m *ice.Message, arg ...string) {

}
func (s meeting) Join(m *ice.Message, arg ...string) {
	if !m.WarnNotRight(!s.IsWorker(m)) {
		m.ProcessOpen(m.Option(model.LINK))
	}
}

func init() { ice.TeamCtxCmd(meeting{Table: newTable()}) }

type MeetingVendor interface {
	MeetingList(m *ice.Message, arg ...string)
}

var meetingVendorKey string
var meetingVendorList = map[string]MeetingVendor{}

func MeetingVendorAdd(key string, vendor MeetingVendor) {
	meetingVendorKey, meetingVendorList[key] = key, vendor
}

func (s meeting) cmdy(m *ice.Message, arg ...ice.Any) *ice.Message {
	msg := s.Select(m.Spawn(), model.PLACE_UID, m.Option(s.PLACE_UID))
	return m.Options("user_id", msg.Append("user_id")).Cmdy(append([]ice.Any{kit.Select(meetingVendorKey, msg.Append("vendor"))}, arg...)...)
}
func (s meeting) authUID(m *ice.Message, arg ...string) string {
	if msg := m.Cmd(s.Place, s.Select, model.UID, arg[0]); msg.Append(model.AUTH_UID) == "" {
		m.Echo("本服务暂未申请认证，请到<用户名片>申请认证")
	} else if _msg := m.Cmd(api.RENZHENGSHOUQUAN_AUTH, s.Select, model.UID, msg.Append(model.AUTH_UID)); _msg.Append(model.AUTH_STATUS) != "2" {
		m.Echo("本服务认证申请中，请等待审批")
	} else {
		return m.Cmd(s.Street, s.Select, model.UID, msg.Append(s.Keys(s.Street, model.UID))).Append(model.AUTH_UID)
	}
	return ""
}
